<template>
  <div class="account">
    <div class="account-title"><b>Маълумотҳо</b> оиди мутахассис</div>
    <div class="account-avatar">
      <img
        v-if="avatarImage || form.avatar"
        :src="avatarImage || form.avatar"
      />
      <img
        v-else
        src="https://storage.yandexcloud.net/nmoms/static/img/icons/icon-empty-user.svg"
      />
      <input
        type="file"
        accept=".png,image/png,.jpg,image/jpg,.jpeg,image/jpeg"
        aria-label="upload image button"
        @change="onFileSelected"
        style="display: none"
        ref="fileInput"
      />
      <button type="button" @click="$refs.fileInput.click()" class="form-btn">
        Таъғири сурат
      </button>
    </div>
    <form @submit.prevent="redactData()">
      <div class="account-form">
        <div>
          <span>Ному насаб пура</span>
          <Input class="account-item" v-model="form.name" required disabled />
        </div>
        <div>
          <span>Телефон</span>
          <Input
            class="account-item"
            v-model="form.phone"
            required
            disabled
            phone
          />
        </div>
        <div>
          <span>Вилоят</span>
          <Select
            single
            class="registration-item"
            :data="regions_list"
            v-model="form.region"
            required
          />
        </div>
        <div>
          <span>Ихтисос</span>
          <Input
            class="account-item"
            v-model="form.specialization"
            required
            disabled
          />
        </div>
        <div>
          <span>Ҷои кор</span>
          <Input class="account-item" v-model="form.workplace" />
        </div>
        <div>
          <span>Таҷрибаи корӣ</span>
          <Input
            class="account-item"
            v-model="form.experience"
            required
            disabled
          />
        </div>

        <div>
          <span>Маълумот</span>
          <Input class="account-item" v-model="form.education" disabled />
        </div>
        <div>
          <span>Санаи таваллуд</span>
          <Input class="account-item" v-model="form.birthday" disabled />
        </div>
        <div
          v-if="
            form.specialization == 'Семейный врач' ||
            form.specialization == 'Семейная медсестсра/брат'
          "
        ></div>
        <div
          v-if="
            form.specialization == 'Семейный врач' ||
            form.specialization == 'Семейная медсестсра/брат'
          "
        >
          <span> Дараҷанокии тахассусии тибби оилавиӣ </span>
          <Input
            class="account-item"
            v-model="form.family_doctor_category"
            required
            disabled
          />
        </div>
        <div
          v-if="
            form.family_doctor_category &&
            form.family_doctor_category !== 'family_doctor_without_category'
          "
        >
          <span>
            Соли гирифтани "{{ form.family_doctor_category }}" дар тибби оилавӣ
          </span>
          <Input
            class="account-item"
            v-model="form.family_doctor_category_year"
            required
            mask="bday"
            placeholder="01.01.2023"
            disabled
          />
        </div>
      </div>
      <button type="submit" class="curve-btn">
        <div>Нигоҳ доштан</div>
      </button>
    </form>
  </div>
</template>

<script>
const REGIONS = [
  "Душанбе",
  "Вилояти Суғд",
  "Вилояти Хатлон",
  "Минтақаҳои тобеи ҷумҳурӣ",
  "Вилояти Мухтори Кӯҳистони Бадахшон",
];
const FAMILY_DOCTOR_CATEGORIES = [
  "Дараҷаи якум",
  "Дараҷаи дуюм",
  "Дараҷаи олӣ",
  "Дараҷаиноки нест",
];
export default {
  layout: "profile",
  middleware: "auth",
  data() {
    return {
      form: {
        name: "",
        phone: "",
        region: "",
        specialization: "",
        workplace: "",
        education: "",
        birthday: "",
        experience: "",
        family_doctor_category: "",
        family_doctor_category_year: "",
        avatar: "",
      },

      regions_list: REGIONS,
      family_doctor_category_list: FAMILY_DOCTOR_CATEGORIES,

      avatarImage: null,
    };
  },
  mounted() {
    this.form = this.$auth.user;
  },
  methods: {
    redactData() {
      this.$axios
        .$post("/profile/changeProfile", this.form)
        .then((response) => {
          console.log("c");
        })
        .catch((error) => {
          console.log(error);
        });
    },

    async onFileSelected(e) {
      const avatar = e.target.files[0];
      if (avatar === undefined) {
        return;
      }
      if (avatar.size > 524288) {
        alert("Андозаи сурат набояд аз 500 килобайт зиёд бошад");
      } else {
        const avatarName =
          this.$auth.user.name +
          this.$auth.user.phone +
          "." +
          avatar.type.split("/").pop().trim();
        const formData = new FormData();
        formData.append("avatar", avatar, avatarName);

        const url = this.$config.UPLOADS_BACKEND_URL + "/uploadAvatar";
        try {
          let response = await this.$axios.$post(url, formData, {
            headers: {
              "content-type": "multipart/form-data",
            },
          });
          if (response.answer === "ok") {
            this.removeAvatar(this.form.avatar);

            this.$axios
              .$post("/profile/uploadAvatar", {
                name: "/avatars/" + avatarName,
                id: this.$auth.user._id,
              })
              .then((response) => {
                if (response.answer === "ok") {
                  const reader = new FileReader();
                  reader.readAsDataURL(avatar);
                  reader.onload = (onloadEvent) => {
                    this.avatarImage = onloadEvent.target.result;
                    this.form.avatar = "/avatars/" + avatarName;
                  };
                }
              });
          }
        } catch (err) {
          console.log(err);
        }
      }
    },

    removeAvatar(avatarName) {
      const userId = this.$auth.user._id;
      const url = this.$config.UPLOADS_BACKEND_URL + "/removeAvatar";
      this.$axios
        .$post(url, {
          path: "./static" + avatarName,
          id: userId,
        })
        .catch((error) => {
          console.log(error);
        });
    },
  },
};
</script>

<style lang="scss" scoped>
.account {
  min-height: 70vh;
  margin-left: 20px;
  padding: 20px;
  background-color: #fff;
  box-shadow: 1px 1.732px 10px 0 rgb(0 0 0 / 5%);
  width: 100%;
  @include less-than(tablet) {
    margin-left: 0px;
  }

  &-title {
    line-height: 1.3;
    font-size: 36px;

    b {
    }
  }

  &-avatar {
    margin-top: 40px;
    display: flex;
    align-items: center;
    @include less-than(tablet) {
      margin-top: 20px;
      margin-left: 10px;
      justify-content: center;
      flex-wrap: wrap;
      flex-direction: column;
    }
    img {
      width: 120px;
      height: 120px;
      border: 1px solid #ccc;
      object-fit: cover;
    }
    button {
      margin-left: 40px;
      transition: all ease 0.3s;
      @include less-than(tablet) {
        margin-left: 0px;
        margin-top: 15px;
      }
      &:hover {
        border-color: #0c63e4;
        color: #0c63e4;
      }
    }
  }

  &-form {
    margin-top: 40px;
    display: grid;
    grid-template-columns: repeat(3, 1fr);
    text-align: left;
    grid-gap: 40px;
    @include less-than(tablet) {
      grid-template-columns: repeat(1, 1fr);
      grid-gap: 20px;
    }
    span {
      display: block;
      margin-bottom: 5px;
    }
  }
  .curve-btn {
    margin: 40px 10px;
    @include less-than(tablet) {
      margin: 40px 0px;
      width: 100%;
      div {
        display: flex;
        justify-content: center;
      }
    }
  }
}
</style>
